-- Tree Setup script

-- made by Alistaire

--[[

TS_addtree
	nr		=		number for the image	(Tree*nr*.png)
	x		=		n/n
	y		=		n/n
	s1		=		minimal size			(x 100 factor!)
	s2		=		maximal size			(x 100 factor!)

*NOTE: Normal x size - double y size must be written like -> TS_addtree(nr, x, y, 100, 200)! *
	
	random false
		rc		=		Red value 			(RGB)
		gc		=		Green value 		(RGB)
		bc		=		Blue value 			(RGB)
	
	random true
		rc		=		Minimal red value 	(RGB)
		gc		=		Minimal green value (RGB)
		bc		=		Minimal blue value 	(RGB)
		rc2		=		Maximal red value 	(RGB)
		gc2		=		Maximal green value (RGB)
		bc2		=		Maximal blue value 	(RGB)

*NOTE: You can edit 'directory' to whatever directory you want to get images from there! *

e.g

TS_addtree(6, x, y, 120, 150, 180, 180, 180, true, 180, 255, 180)

--]]

TS_tree = {}

val = 1
directory = 'gfx/TreeSetup/'

function TS_addtree(nr, x, y, s1, s2, rc, gc, bc, random, rc2, gc2, bc2)
	if rc and gc and bc then
		if random then
			if rc2 and gc2 and bc2 then
				b1 = math.random(rc, rc2)
				b2 = math.random(gc, gc2)
				b3 = math.random(bc, bc2)
			else
				print('TreeSetup.lua -> ERROR - rc2, gc2 and bc2 are not declared for tree '..nr)
			end
		else
			b1 = rc
			b2 = gc
			b3 = bc
		end
	else
		b = math.random(180, 255)
		b1 = b
		b2 = b
		b3 = b
	end
	if s1 and s2 then
		if s1 == 1 then
			print('TreeSetup.lua -> ERROR - You clearly didn\'t read the FUCKING DESCRIPTION! s1 and s2 at normal size is 100! Not 1!')
		end
		c = math.random(s1, s2) / 100
	else
		c = math.random(100, 140) / 100
	end
	TS_tree[val] = image(directory..'Tree'..nr..'.png', x, y, 1)
	imagepos(TS_tree[val], x * 32 + 16, y * 32 + 16, math.random(0, 360))
	imagecolor(TS_tree[val], b1, b2, b3)
	imagescale(TS_tree[val], c, c)
	val = val + 1
end

-- Small trees (first layer)
for y = 0, map('ysize') do
	for x = 0, map('xsize') do
		local a = entity(x, y, 'name')
		if a == 'tree1' then
			TS_addtree(1, x, y)
		elseif a == 'tree2' then
			TS_addtree(1, x, y, 100, 150, 200, 200, 200, true, 200, 255, 200)
		elseif a == 'tree4' then
			TS_addtree(3, x, y)
		end
	end
end

-- Big trees (second layer)
for y = 0, map('ysize') do
	for x = 0, map('xsize') do
		local a = entity(x, y, 'name')
		if a == 'tree3' then
			TS_addtree(1, x, y, 200, 220, 255, 255, 255)
		elseif a == 'tree5' then
			TS_addtree(3, x, y, 200, 220, 255, 255, 255)
		end
	end
end